//Filters by D. Mitchell
image gaussianblur(image sourceimg, number blurvalue)
	{
	number imagexsize, imageysize
	getsize(sourceimg, imagexsize, imageysize)
	compleximage fftsource=realfft(sourceimg)
			
	compleximage gauss:=ExprSize(imagexsize, imageysize,exp(-((irow-(imageysize/2))**2+(icol-(imagexsize/2))**2)/(blurvalue**2)))			
	compleximage gaussfft=fft(gauss)
	compleximage fftproduct=fftsource*gaussfft.modulus().sqrt()
		
	converttopackedcomplex(fftproduct)
	image product=packedifft(fftproduct)
		
	return product
	}

image butterworth(image sourceimg)
	{
	number imagexsize, imageysize
	getsize(sourceimg, imagexsize, imageysize)
	image butterworthimg=realimage("",4,imagexsize, imageysize)
			
	// Settings from the Butterworth filter
	number halfpointconst=0.414
	number bworthorder=3
	number zeroradius=(imagexsize/2)*0.7

	// Create the butterworth image - by default the butterworth image is a lo pass
	// filter ie 1 near the centre and 0 at the periphery

	butterworthimg=1/(1+halfpointconst*(iradius/zeroradius)**(2*bworthorder))
	image product=sourceimg*butterworthimg
	return product
	}
		
image CustomerFilter(image in)
{
number blurr =2

image out 
//define here the filters you want
out :=gaussianblur(in,blurr)
//out :=butterworth(in)

return out
}

void CrossShiftsCustom(number &delX,number &delY,image Cross)
	{
	//define hjer how to determne the drift from cross correlation of two consequent images
	
	//simple taking the max of cross correlation is default
	Cross.max(delX,delY)
	delX -=cross.imageGetDimensionSize(0)/2
	delY -=cross.imageGetDimensionSize(1)/2
	}		