string FormatedValue112(number value,number reg)
	{
	//This makes the output drift value formated, i.e. not too long 
	number regP =reg -1

	string out

	if((value>0.01)&&(value<0.1)) out =""+format(value,"%-"+reg+"."+(reg+1)+"f") 
	if((value>0.1)&&(value<1)) out =""+format(value,"%-"+reg+"."+(reg)+"f") 
	if((value>1)&&(value<10)) out =""+format(value,"%-"+reg+"."+(reg-1)+"f") 
	if((value>10)&&(value<100)) out =""+format(value,"%-"+reg+"."+(reg-2)+"f") 
	if((value>100)&&(value<1000)) out =""+format(value,"%-"+reg+"."+(reg-3)+"f") 

	return out
	}

image makeReference112(image in,number filter)
	{
	//Applies smoothing filter if requested
	
	if(filter) return in.CustomerFilter()
	else return in
	}
	
	
class trackDrift_112:UIFrame112
{
//stored parameters
number maxTrack	//max number of measurement in the drift display
number showTrack	//the number of drift measurements currently displayed
number takt		//the periodicity of measurement in sec
number selectROI	//whether to measure drift on selected ROI or whole image
number filter	//whether to apply a smoothing filter

//their names to store in tags
string maxTrackName
string showTrackName
string taktName
string selectName
string filterName

//technical parameters
number liveID, storedID, TrackID
number ListID, ROI_ID
number buzy
number t0
number count

image stored	//reference for cross correlation
image Drift		//display drift

//calibration of live image
number scale
string units

//for frame display
number size1,size2
number bcgr1,bcgr1out,bcgr2


image LoadedLabel(object self, string message,number size,number background)
	{
	return self.GraphicFromString(message,size,"",2,background)
	}

image Compass(object self, number dX,number dY,number size,number background,number backgroundOut)
	{
	//This creates the arrow indicating the drift direction
	
	image compass =self.Iarrow(0,size,background,0)
	if((dX==0)&&(dY==0)) compass =tert(iradius<size/8,0,background)

	image compassRot =compass.rotate(atan2(dY,dX))
	compassRot =tert(iradius>size/2,backgroundOut,compassRot)
	
	number height =compassRot.ImagegetDimensionSize(1)
	
	number top =round((height -size)/2) 
	number bottom =top +size
//result("\nheight "+height+" top "+top+" bottom "+bottom)	

	return compassRot[top,top,bottom,bottom]
	}
	
	
TagGroup CreateAssign(object self)
	{
	TagGroup dialog = DLGCreateBox("assign live image").DLGTableLayout(3,2,0);
	
	Dialog.DLGAddElement(DLGCreateLabel("live:").DLGAnchor("West"))			
	Dialog.DLGAddElement(DLGCreatePushButton("assign", "assign"))	
	Dialog.DLGAddElement(DLGCreateLabel("    ",4).DLGIdentifier("assigned"))
	
	Dialog.DLGAddElement(DLGCreateCheckbox("ROI",0,"changeSelect").DLGIdentifier("ROI").DLGAnchor("West"))
	Dialog.DLGAddElement(DLGCreatePushButton("select", "select").DLGIdentifier("selectROI"))
	Dialog.DLGAddElement(DLGCreateCheckbox("filter",0).DLGIdentifier("filter").DLGAnchor("West"))
	
	return dialog
	}

TagGroup CreateStart(object self)
	{
	TagGroup dialog = DLGCreateDialog("track drift from live image").DLGTableLayout(4,1,0);
	
	Dialog.DLGAddElement(DLGCreateLabel("takt:").DLGAnchor("East"))
	Dialog.DLGAddElement(DLGCreateRealField(10,4,1).DLGIdentifier("takt"))
	Dialog.DLGAddElement(DLGCreatePushButton("start", "Track").DLGIdentifier("track"))
	Dialog.DLGAddElement(DLGCreatePushButton("stop", "Stop").DLGIdentifier("stop").DLGanchor("West"))
		
	return dialog
	}
	
TagGroup CreateMonitor(object self)
	{
	TagGroup dialog = DLGCreateDialog("track drift from live image")//.DLGTableLayout(1,2,0);
	
	image compass =self.compass(0,0,size1,bcgr1,bcgr1out)

	Dialog.DLGAddElement(DLGCreateGraphic(size1,size1).DLGAddBitmap(compass).DLGIdentifier("compass"))	
	Dialog.DLGAddElement(DLGCreateGraphic(size2,size2/2).DLGAddBitmap(self.LoadedLabel("    ",size2/2,bcgr2)).DLGIdentifier("drift").DLGanchor("West"))
	
	return dialog
	}
	
	
TagGroup CreateAll(object self)
	{
	TagGroup dialog = DLGCreateDialog("Dialog");

	dialog.DLGAddElement(self.CreateAssign())
	dialog.DLGAddElement(self.CreateStart())
	dialog.DLGAddElement(self.CreateMonitor())
	
	return Dialog
	}


object init(object self,string Package,string Name,string LabelP)
	{
	//names to store parameters
	maxTrackName ="maxTrack"
	showTrackName ="showTrack"	
	taktName ="takt"	
	selectName ="ROIselect"
	filterName ="filter"
	
	//for compass display
	size1 =120
	bcgr1 =200
	bcgr1out =210	
	
	//for drift value display
	size2 =80
	bcgr2 =200
	
	//initialize extended frame
	self.initUIFrame112(self.CreateAll(),Package,Name)

	//read the parameters
	maxTrack =self.LoadNumber112(1000,maxTrackName)	//default 1000 max measurements
	showTrack =self.LoadNumber112(20,showTrackName)	//default 20 currently displayed measurements
	takt =self.LoadNumber112(5,taktName)			//default periodicity 5 sec
	selectROI =self.LoadNumber112(0,selectName)		//default not select ROI
	filter =self.LoadNumber112(0,filterName)		//default not smooth
	
	try{	//set dislayed parameters
		self.LookUpElement("takt").DLGValue(takt)	
		self.LookUpElement("ROI").DLGValue(selectROI)	
		self.LookUpElement("filter").DLGValue(filter)
		}
	catch{break;}

	self.SetElementIsEnabled("stop",0)
	self.SetElementIsEnabled("track",0)
	if(selectROI==0) self.SetElementIsEnabled("selectROI",0)
	
	return self
	}


void changeSelect(object self,tagGroup tg)
	{
	selectROI =self.LookUpElement("ROI").DLGGetValue()	

	if(selectROI==0) self.SetElementIsEnabled("selectROI",0)
	else self.SetElementIsEnabled("selectROI",1)
	}
	
	
void CloseUIFrame112(object self)
	{
	//add some actions if neccesary
	}
	
number AboutToCloseUIFrame112( object self, number verify )
	{
	//read current settings	
	takt =self.LookUpElement("takt").DLGGetValue()
	selectROI =self.LookUpElement("ROI").DLGGetValue()
	filter =self.LookUpElement("filter").DLGGetValue()
	
	//store current settings
	self.StoreNumber112(maxTrack,maxTrackName)	
	self.StoreNumber112(showTrack,showTrackName)
	self.StoreNumber112(takt,taktName)
	self.StoreNumber112(selectROI,selectName)
	self.StoreNumber112(filter,filterName)
	
	//disconnect
	liveID.GetImageFromID().ImageRemoveEventListener(ListID)	
result("\ndisconnected")

	try{	//delete selected ROI if exist
		image search :=liveID.GetImageFromID()
		imagedisplay disp =search.ImageGetImageDisplay(0)
		ROI selected =GetROIFromID(ROI_ID)
		Disp.ImageDisplayDeleteROI(selected)
		}
	catch{break;}
	}


void CreateDriftMonitor(object self)
	{
	//This is the display to record the drift vs time
	drift :=realimage("D",4,maxTrack,3)
	
	drift.showimage()
	drift.setName("drift monitor")
	drift.SetDisplayType(4)
	drift.ImageSetDimensionCalibration(0,0,takt,"s",1)
	drift.ImageSetIntensityUnitString(units+"/min ")
	
	imagedisplay disp =drift.ImageGetImageDisplay(0)
	
	disp.LinePlotImageDisplaySetBackgroundOn(0)
	disp.LinePlotImageDisplaySetGridOn(0)
	disp.LinePlotImageDisplaySetLegendShown(1)
	
	disp.ImageDisplaySetSliceLabelById(disp.ImageDisplayGetSliceIdByIndex(0),"drift" )
	disp.ImageDisplaySetSliceLabelById(disp.ImageDisplayGetSliceIdByIndex(1),"drift X" )
	disp.ImageDisplaySetSliceLabelById(disp.ImageDisplayGetSliceIdByIndex(2),"drift Y" )
	
	disp.LinePlotImageDisplaySetDisplayedChannels(0,showTrack)
	}

	
void ExtractDrift(object self, image current)
	{
	//basic module to track drift
	
	buzy =1	
	
	if(storedID !=0)	//make cross correlation only if previous reference is available
		{
		image stored :=storedID.GetImageFromID()
		
		image Cross =CrossCorrelation(current,stored)
		
		number delX,delY
		CrossShiftsCustom(delX,delY,Cross)
		
		delX *=(scale/takt*60)
		delY *=(scale/takt*60)

		number del =sqrt(delX**2 +delY**2)
result("\ndrift "+del+" dX "+units+"/min "+delX+" "+units+"/min dY "+delY+" "+units+"/min")	
	
		//stop if exceeds thje max measurements
		if(count==maxTrack) self.Stop()
	
		//register drift
		if(count>0)
			{
			try
				{
				//register on drift display
				drift.setPixel(count,0,del)
				drift.setPixel(count,1,delX)
				drift.setPixel(count,2,delY)
				if(count>=showTrack)
					{
					drift.ImageGetImageDisplay(0).LinePlotImageDisplaySetDisplayedChannels(count-showTrack,count)
					}	
				}
			catch break
			
			//register direction in monitor
			self.LookUpElement("compass").DLGGetElement(0).DLGBitmapData(self.compass(delX,-delY,size1,bcgr1,bcgr1out))
			
			//register value in monitor
			self.LookUpElement("drift").DLGGetElement(0).DLGBitmapData(self.LoadedLabel(FormatedValue112(del,4),size2/4,bcgr2))
			}
			
		count ++
		}
		
	buzy=0
	}
	
	
void GetDrift(object self, number e_fl, image Img)
	{
	//reacts on live image update
	number dt =CalcOSsecondsBetween(t0,getOstickCount())
	
	//measures drift only takt periodicity has passed and if the script is not busy with cross correlation
	if((dt>=takt)&&(!buzy))
		{	
//result("\ntakt "+dt)
		//calculate drift since last reference 
		image current 
		
		if(selectROI)	//correlation on ROI
			{
			ROI selected =GetROIFromID(ROI_ID)
			number Xini,Xfin,Yini,Yfin
			selected.ROIGetRectangle(Yini,Xini,Yfin,Xfin)
			
			current =liveID.GetImageFromID()[Yini,Xini,Yfin,Xfin].makeReference112(filter)
			}
		else current =liveID.GetImageFromID().makeReference112(filter)
		
		self.ExtractDrift(current)	
		
		//create/update previous reference
		stored =current
		if(storedID ==0) storedID =stored.ImageGetID()
		
		//update reference time tick
		t0 =getOstickCount()		
		}
	}
	
	
void GetCalibration(object self, number e_fl, image search)
	{
	//react on the calibration change (due to mag change)in the live image 
	number origin //dummy
	search.ImageGetDimensionCalibration(0,origin,scale,units,1)
	
//result("\nscale "+scale+" units "+units)
	}
	
	
void Track(object self)
	{
	//start tracking
	image search
	
	try{deleteImage(stored);}
	catch{break;}
	storedID =0
	
	try{
	search :=liveID.GetImageFromID()
		}
	catch{
		OKDialog("Cannot find live image !!")
		exit(0)
		}
	
	//if cross correlation on ROI, check whether the ROI is defined	
	if(selectROI==1) if(ROI_ID==0) {OKDialog("Select 2^n (ALT pressed) ROI  first !!"); exit(0);}
	
	takt =self.LookUpElement("takt").DLGgetvalue()

	//attach listeners
	string messageMap ="data_changed:GetDrift;"
	messageMap +="calibration_changed:GetCalibration"
	ListID = search.ImageAddEventListener( self,messageMap)

	self.GetCalibration(0,liveID.GetImageFromID())	
	
	//update drift monitor
	self.CreateDriftMonitor()
	
	self.SetElementIsEnabled("track",0)
	self.SetElementIsEnabled("stop",1)
	}


void Stop(object self)
	{
	//stop tracking
	count =0
	t0=0
	
	liveID.GetImageFromID().ImageRemoveEventListener(ListID)	
	result("\ndisconnected")
	
	self.SetElementIsEnabled("track",1)
	self.SetElementIsEnabled("stop",0)
	}


void Assign(object self)
	{
	//assign live image
	
	//check if it isnot already assigned
	if(liveID!=0) if(!OKcancelDialog("live image is already assigned\nDo you want to assign another one ?")) exit(0)
	
	image search :=getFrontImage()
	liveID =search.ImageGetID()

	//show the live image label
	self.LookUpElement("assigned").DLGTitle(""+search.ImageGetLabel())
	
	self.SetElementIsEnabled("track",1)
	}

void Select(object self)
	{
	//select ROI
	
	if(liveID!=0) //only if live image already assigned
		{
		image search :=liveID.GetImageFromID()
		ImageDisplay Disp = search.ImageGetImageDisplay(0)
		
		//find rectangular ROI
		ROI selected 
		for(number i=0;i<Disp.ImageDisplayCountROIS();i++)
			{
			selected =Disp.ImageDisplayGetROI(i)
			if(selected.ROIIsRectangle()) break
			}		
		
		//check if ROI is drawn
		if(!selected.ROIIsValid()) 
			{
			OKdialog("Draw quadratic 2^n (ALT pressed) ROI first !!")
			exit(0)
			}
			
		ROI_ID= selected.ROIGetID()
result("\nROI_ID "+ROI_ID)

		//spectrum-image area appearance
		selected.ROISetColor(0,1,0)
		selected.ROISetVolatile(0)
		selected.ROISetLabel("correlation")		
		}
	else OKdialog("assign live image first !!")	
	}
		
}

{
//check if ExtendedFrames are loaded
if(!doesFunctionExist("LoadNumber112")) 
	{
	OKdialog("Please drop 'temDM extFrames.gt3' plugin in the plugins folder !!");
	exit(0);
	}

alloc(trackDrift_112).init("_temDM-Scripts:trackDrift","track drift","trackDrift") 
}